//
//  MainListInteractorTests.swift
//  Marveler
//
//  Created by Arash on 12/8/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the Clean Swift Xcode Templates so
//  you can apply clean architecture to your iOS and Mac projects,
//  see http://clean-swift.com
//

@testable import Marveler
import XCTest

class MainListInteractorTests: XCTestCase {
    // MARK: Subject under test
    
    var sut: MainListInteractor!
    
    // MARK: Test lifecycle
    
    override func setUp() {
        super.setUp()
        setupMainListInteractor()
    }
    
    override func tearDown() {
        super.tearDown()
    }
    
    // MARK: Test setup
    
    func setupMainListInteractor() {
        let webService = WebServiceSuccessMock()
        webService.seed = Seed.Main.list
        let auth = Auth()
        sut = MainListInteractor(webService: webService, auth: auth)
    }
    
    // MARK: Test doubles
    
    class MainListPresentationLogicSpy: MainListPresentationLogic {
        var results: [ServerModels.Response.Result] = []
        var presentPrepareCalled = false
        
        func presentPrepare(response: MainList.Prepare.Response) {
            presentPrepareCalled = true
            results = response.list
        }
    }
    
    // MARK: testPresentPrepareCalled
    func testPresentPrepareCalled() {
        
        //Given
        let spy = MainListPresentationLogicSpy()
        sut.presenter = spy
        let request = MainList.Prepare.Request()
        
        //When
        sut.prepare(request: request)
        
        //Then
        XCTAssertTrue(spy.presentPrepareCalled, "should ask the presenter to present the result")
    }
    
    // MARK: testPresentPrepareCalled
    func testResultsCount() {
        
        //Given
        let spy = MainListPresentationLogicSpy()
        sut.presenter = spy
        let request = MainList.Prepare.Request()
        
        //When
        sut.prepare(request: request)
        
        //Then
        XCTAssertEqual(spy.results.count,Seed.Main.list.count, "should be equal")
    }
}
